<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Home - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Controller.html">Controller</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Controller.html#iterate">iterate</a></li></ul></li><li><a href="Criterion.html">Criterion</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Criterion.html#cost">cost</a></li></ul></li><li><a href="Driver.html">Driver</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Driver.html#get">get</a></li><li data-type='method' style='display: none;'><a href="Driver.html#set">set</a></li></ul></li><li><a href="Numeric.html">Numeric</a><ul class='members'><li data-type='member' style='display: none;'><a href="Numeric.html#count">count</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Numeric.html#asString">asString</a></li></ul></li><li><a href="Optimizer.html">Optimizer</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Optimizer.html#minimize">minimize</a></li></ul></li></ul>
    
</nav>

<div id="main">
    

    



    


    <section class="package">
        <h3> </h3>		
    </section>









    



    <section class="readme usertext">
        <article><h1>stepsolver</h1>
<p>A step by step variational solver mechanism</p>
<div style='float:right;margin-left:20px'><a target=_blank' href='https://line.gitlabpages.inria.fr/aide-group/aide/index.html'><img alt='AIDE API docs' src='https://line.gitlabpages.inria.fr/aide-group/aide/img/icons8-api-aide.png'/></a></div>
<h2>Presentation</h2>
<p>This factory encapsulates step by step variational solver mechanism.</p>
<ul>
<li>
<p>The design choice here is to consider fully defined numerical value <a href="Numeric.html">Numeric</a>:</p>
<ul>
<li>Bounded between a <code>min</code> and <code>max</code> value.</li>
<li>A numerical precision <code>eps</code> under which two values are indistinguishable.</li>
<li>A sampling <code>step</code> if the value lies in a non convex neighborhood.</li>
<li>A default and initial value.</li>
<li>A physical unit, if applicable.</li>
</ul>
</li>
<li>
<p>Here two basic algorithms are implemented:</p>
<ul>
<li>An <a href="Optimizer.html">Optimizer</a> minimizing a <a href="Criterion.html">Criterion</a> allowing to locally find a solution to a system of equations in a deterministic way, without additional hyperparameters.</li>
<li>A <a href="Controller.html">Controller</a> of a look-and-move <a href="Driver.html">Driver</a> mechanism allowing to drive an external mechanism connected to the driver towards desired values.</li>
</ul>
</li>
<li>
<p>In both cases a step by step, slow but robust reproducible mechanism is obtained.</p>
</li>
</ul>
<p><a name='what'></a></p>
<h2>Package repository</h2>
<ul>
<li>Package files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/stepsolver'>https://gitlab.inria.fr/line/aide-group/stepsolver</a></li>
<li>Package documentation: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/stepsolver'>https://line.gitlabpages.inria.fr/aide-group/stepsolver</a></li>
<li>Source files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/stepsolver/-/tree/master/src'>https://gitlab.inria.fr/line/aide-group/stepsolver/-/tree/master/src</a></li>
<li>Saved on <a target='_blank' href='https://archive.softwareheritage.org/browse/origin/directory/?origin_url=https://gitlab.inria.fr/line/aide-group/stepsolver'>softwareherirage.org</a></li>
<li>Version <code>1.1.1</code></li>
<li>License <code>CECILL-C</code></li>
</ul>
<h2>Installation</h2>
<h3>User simple installation</h3>
<ul>
<li><code>npm install git+https://gitlab.inria.fr/line/aide-group/stepsolver.git</code></li>
</ul>
<h3>Co-developper installation</h3>
<ul>
<li>See the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html#.install_as_developer'>related documentation</a></li>
</ul>
<p>Please refer to the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html'>installation guide</a> for installation.</p>
<p><a name='how'></a></p>
<h2>Usage</h2>
<h3>npm script usage</h3>
<pre class="prettyprint source"><code>npm install --quiet : installs all package dependencies and sources.
npm run build: builds the different compiled, documentation and test files.
npm test     : runs functional and non-regression tests.
npm run clean: cleans installation files.
</code></pre>
<p><a name='dep'></a></p>
<h2>Dependencies</h2>
<ul>
<li><tt>aidesys: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidesys'>Basic system C/C++ interface routines to ease multi-language middleware integration</a></tt></li>
<li><tt>wjson: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/wjson'>Implements a JavaScript JSON weak-syntax reader and writer</a></tt></li>
</ul>
<h2>devDependencies</h2>
<ul>
<li><tt>aidebuild: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild'>Builds multi-language compilation packages and related documentation.</a></tt></li>
</ul>
<p><a name='who'></a></p>
<h2>Author</h2>
<ul>
<li>Thierry Viéville <a href="mailto:thierry.vieville@inria.fr">thierry.vieville@inria.fr</a></li>
</ul></article>
    </section>






    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>